//
// Implementazione della Classe List: doppi puntatori con "sentinella"
// Seconda versione: utilizzo di templates ed ereditarieta`.
//


#include <iostream.h>
#include "List2.H"


// Costruttore per il tipo di dato Lista.
BaseList::BaseList()
{
  sentinel = new BaseNode;			// Creo il nodo sentinella
  sentinel->next = sentinel->prev = sentinel;	// Inizializzo la sentinella

  current = sentinel;

  len = 0;
}


// Distruttore per il tipo di dato Lista
BaseList::~BaseList()
{
  GoToFirst();			// Vai al primo elemento della Lista

  while (!IsEndOfList())	// Finche non sono arrivato alla sentinella
    Delete();			// Cancella un elemento

  delete sentinel;		// Elimina infine anche la sentinella
}


// Spostiamo il nodo corrente sul nodo successivo
ListPos BaseList::Next()
{
  if (IsEndOfList()) {		// Errore se siamo alla fine della Lista
    cerr << "Errore: Next(), non puoi scavalcare la sentinella!"
	 << endl;
    exit(-2);
  }

  return(current = current->next);
}


// Spostiamo il nodo corrente sul nodo precedente
ListPos BaseList::Previous()
{
  if (IsFirst()) {		// Non si puo` andare oltre il primo elemento
    cerr << "Errore: Previous(), non possiamo andare sulla sentinella!"
	 << endl;
    exit(-2);
  }

  return(current = current->prev);
}



// Inserimento nella Posizione corrente
ListPos BaseList::Insert(BaseNode *d)
{
  d->prev = current->prev;	// Il nuovo nodo e` inserito PRIMA del nodo
  d->next = current;		// corrente

  current->prev = d;
  d->prev->next = d;

  len++;

  return(d);
}


// Cancella l'elemento nella posizione corrente
BaseNode* BaseList::Delete()
{
  if (IsEndOfList()) { 
    cerr << "Error: Delete(), non e` possibile cancellare la sentinella!"
	 << endl;
    exit(-2);
  }

  BaseNode *tmpp = current;		// Salviamo la posizione corrente

  current->next->prev = current->prev;
  current->prev->next = current->next;

  len--;

  current = current->next;		// Spostiamo in avanti la posizione
					// del nodo corrente

  return(tmpp);				// Restituiamo il puntatore al nodo
}
